#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "manager4xi.py">
#<abstract4xi abstract = "provides the function Manager4Xi"/>
#<refer4xi reference = "__init__.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Manager4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing import Manager  # note: you can not import Manager from module __init__.py 
                                         #       instead you import the whole packet
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arbitrary_address4xi import arbitrary_address4xi
from constant_family4xi import ConstantFamily4Xi
from examine4xi import examine4xi
from print4xi import print4xi
from syncmanager4xi import SyncManager4Xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "Manager4Xi" usage = "
#
#   test_all_methods4xi.py: 
#       manager2xi = Manager4Xi() <-- (and all programs wanting to use this function) 
#
#   __init__.py:
#       Manager():
#           from multiprocessing.managers import SyncManager 
#           m = SyncManager()
#           m.start()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# --------------------------------------------------------------------------------------------- 

def Manager4Xi():
    '''
    returns a manager associated with a running server process
    '''
   
    # -----------------------------------------------------------------------------------------    
    # (Step 1/5)
    # -----------------------------------------------------------------------------------------        
    
    class2print = "Manager4Xi"
    method2print = "Manager4Xi"
        
    message2print = "{(Step 1/5a) started" + "; Manager4Xi-started: " + str(Manager4Xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)            
    #PX: <function Manager4Xi at 0x02DE9198>

       
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                 
    if examine4xi(class2print, method2print):
        
        # -------------------------------------------------------------------------------------    
        # (StepOriginal)
        # -------------------------------------------------------------------------------------             
        message2print = "{(StepOriginal) returning" + "; Manager-function-returning-by-Manager4Xi: " + str(Manager) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function Manager at 0x0000000002ADE488>; time: 05:11:05 04/19/13 Pacific Daylight Time}
                
        return Manager()
    
    else:
    
        # -------------------------------------------------------------------------------------    
        # (Step 1/5)
        # -------------------------------------------------------------------------------------        
  
        manager2xi = None        
   
               
        message2print = "{(Step 1/5a) creating" + "; SyncManager4Xi-creating-by-Manager4Xi: " + str(SyncManager4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                             
        #PX: <class 'syncmanager4xi.SyncManager4Xi'>          

        cf2xi = ConstantFamily4Xi()
        
        message2print = "{(Step 1/5b) set" + "; cf2xi-set-by-Manager4Xi to: " + str(cf2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #PX: <constant_family4xi.ConstantFamily4Xi object at 0x0304A270>
    
        # -------------------------------------------------------------------------------------    
        # (Step 2/5) 
        # -------------------------------------------------------------------------------------        
           
        family2dragonxi = cf2xi.get_default_family()                  #dragonized
            
        message2print = "{(Step 2/5a) set" + "; family2dragonxi-set-by-Manager4Xi to: " + str(family2dragonxi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #PX: AF_PIPE
    
        # -------------------------------------------------------------------------------------    
        # 
        # -------------------------------------------------------------------------------------        
           
        hub2sync = arbitrary_address4xi(family2dragonxi)      #dragonized
            
            
        message2print = "{(Step 2/5b) set" + "; hub2sync-set-by-Manager4Xi to: " + str(hub2sync)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #PX: \\.\pipe\pyc-2184-0-guyazg
    
        # -------------------------------------------------------------------------------------    
        # 
        # -------------------------------------------------------------------------------------        
           
        passport2manager = os.urandom(32)
        
        message2print = "{(Step 2/5c) set" + "; passport2manager-set-by-Manager4Xi to: " + str(passport2manager)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)          
        #PX: b'\xc3\xfb\r\x9e\xed\xe5sQ\x8c\x01\xb7\x9c\xc7\xe8\x9a\xe9G\x82\x19\x8e\xa4Y\xd2E\x9c\x0e\xa1%\xfc&\xd6@'

        
        force2manager = 'pickle'
        
        message2print = "{(Step 2/5d) set" + "; force2manager-set-by-Manager4Xi to: " + str(force2manager)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        #PX: pickle
            
        # -------------------------------------------------------------------------------------    
        # 
        # -------------------------------------------------------------------------------------        
           
        message2print = "{(Step 2/5e) passing" + "; passport2manager-passing-to-SyncManager4Xi-by-Manager4Xi: " + str(passport2manager) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #PX: b'\xc3\xfb\r\x9e\xed\xe5sQ\x8c\x01\xb7\x9c\xc7\xe8\x9a\xe9G\x82\x19\x8e\xa4Y\xd2E\x9c\x0e\xa1%\xfc&\xd6@'
                
        message2print = "{(Step 2/5f) passing" + "; hub2sync-passing-to-SyncManager4Xi-by-Manager4Xi: " + str(hub2sync) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #PX: \\.\pipe\pyc-2184-0-guyazg        
                
        message2print = "{(Step 2/5g) passing" + "; force2manager-passing-to-SyncManager4Xi-by-Manager4Xi: " + str(force2manager) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                             
        ack2dragon = False
        nack2dragon = True
        
        manager2xi = None
        
        try:
            # ---------------------------------------------------------------------------------    
            # (Step 3/5)
            # ---------------------------------------------------------------------------------          
        
            manager2xi = SyncManager4Xi(hub2sync, passport2manager, force2manager) 
            
            ack2dragon = True
            
            message2print = "{(Step 3/5a) created" + "; manager2xi-created-by-Manager4Xi: " + str(manager2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
            #PX: <syncmanager4xi.SyncManager4Xi object at 0x0330B9B0>      
     
            message2print = "{(Step 3/5b) commanding" + "; start-commanding-manager2xi: " + str(manager2xi.start) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #PX: <bound method SyncManager4Xi.start of <syncmanager4xi.SyncManager4Xi object at 0x0330B9B0>>
            #    
            
            
            manager2xi.start() 
            
            message2print = "{(Step 3/5c) started" + "; manager2xi-start-started: " + str(manager2xi.start)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            #PX: <bound method SyncManager4Xi.start of <syncmanager4xi.SyncManager4Xi object at 0x0305A5D0>>
            #    SyncManager4Xi : start ; (Step 0/12a) started; start-of-SyncManager4Xi-started: 11:59:19 04/03/10 FLE Daylight Time     
                   


        except:
            message2print = "{(Step 3/5d) yielded" + "; nack2dragon-yielded-by-Manager4Xi: " + str(nack2dragon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 

            # SyncManager4Xi : start ; (Step 9/12d) hit; exception-hit-by-start-of-SyncManager4Xi:  *** failed in receiving - reception_trial_counter2xi = 33 *** ; time: 11:03:43 04/03/10 FLE Daylight Time}
            # { SyncManager4Xi : start ; (Step 10/1a) calling; reader2xi-close-calling-by-start-of-SyncManager4Xi: <built-in method close of _multiprocessing.PipeConnection object at 0x02B8A6A0>; time: 11:03:43 04/03/10 FLE Daylight Time}
            # { SyncManager4Xi : start ; (Step 11/12) set; state-value-of-syncmanager2xi-set-by-start-of-SyncManager4Xi to: 1; time: 11:03:43 04/03/10 FLE Daylight Time}
            #  Manager4Xi : Manager4Xi ; (Step 4/5) hit; manager2xi-hit-by-Manager4Xi:  *** <syncmanager4xi.SyncManager4Xi object at 0x0305A5D0> *** ; time: 11:03:43 04/03/10 FLE Daylight Time}



            
        # -------------------------------------------------------------------------------------    
        # (Step 4/5)
        # -------------------------------------------------------------------------------------
                
        if ack2dragon is True:
        
            knowledgebase2manager = manager2xi.sense()
            
            message2print = "{(Step 4/5) analyzed" + "; knowledgebase2manager-analyzed-by-Manager4Xi: " + str(knowledgebase2manager) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)
            #PX:
            # {'state-of-syncmanager2xi': <state4xi.State4Xi object at 0x031588B0>,
            #  'utilc2xi-of-SyncManager4Xi': <constant_util4xi.ConstantUtil4Xi object at 0x02FEDEF0>,
            #  'synchronizec2xi-of-SyncManager4Xi': <constant_synchronize4xi.ConstantSynchronize4Xi object at 0x02FEDF90>,
            #  'forkingc2xi-of-SyncManager4Xi': <constant_forking4xi.ConstantForking4Xi object at 0x02FEDD30>, 
            #  'systemc2xi-of-SyncManager4Xi': <constant_system4xi.ConstantSystem4Xi object at 0x02FEDED0>, 
            #  'Client-of-syncmanager2xi': <function Client4Xi at 0x02EA2C00>, 
            #  'processc2xi-of-SyncManager4Xi': <constant_process4xi.ConstantProcess4Xi object at 0x02FEDE90>, 
            #  'authkey-of-syncmanager2xi': b'}u\x12\xa1\xa0\x0cgl\xd4\x96\x92\xe7;\x83\xd0/\xc6\n\x80=*=\x00q+}\x11]!Q\xca\x17', 
            #  'ack2connection-of-SyncManager4Xi': True, 
            #  'Server-of-SyncManager4Xi': <class 'server4xi.Server4Xi'>, 
            #  'poolc2xi-of-SyncManager4Xi': <constant_pool4xi.ConstantPool4Xi object at 0x02FEDE30>, 
            #  'address-of-syncmanager2xi': None, 
            #  'loggerc2xi-of-SyncManager4Xi': <constant_logger4xi.ConstantLogger4Xi object at 0x02FEDD90>, 
            #  'Listener-of-syncmanager2xi': <class 'listener4xi.Listener4Xi'>, 
            #  'ack2server-of-SyncManager4Xi': True, 
            #  'object': <syncmanager4xi.SyncManager4Xi object at 0x030E3350>, 
            #  'managersc2xi-of-SyncManager4Xi': <constant_managers4xi.ConstantManagers4Xi object at 0x02FEDDD0>, 
            #  'heapc2xi-of-SyncManager4Xi': <constant_heap4xi.ConstantHeap4Xi object at 0x02FEDD70>, 
            #  'familyc2xi-of-SyncManager4Xi': <constant_family4xi.ConstantFamily4Xi object at 0x02FED350>, 
            #  'connectionc2xi-of-SyncManager4Xi': <constant_connection4xi.ConstantConnection4Xi object at 0x02FED310>, 
            #  'serializer-of-syncmanager2xi': 'pickle', 
            
            #
            #  'registry-of-SyncManager4Xi':
            #      def register(cls, typeid, callable=None, proxytype=None, exposed=None, method_to_typeid=None, create_method=True): 
            #                        KEY        CALLABLE = ???                            HOW CAN sense, reason, ace be here although not 4xi ????
            #         cls._registry[typeid] = (callable,                                  exposed,                                                       method_to_typeid, proxytype) 
            
            #    {             'AsyncResult': (None,                                      None,                                                          None,                  <function AutoProxy4Xi at 0x02EDF0C0>), 
            #                 'Condition4Xi': (<function Condition at 0x02837738>,        ('wait', 'notify', 'notify_all', 'sense', 'reason', 'ace'),    None, <class 'conditionproxy4xi.ConditionProxy4Xi'>), 
            #                     'Event4Xi': (<function Event at 0x02837E40>,            ('is_set', 'set', 'clear', 'wait', 'sense', 'reason', 'ace'),  None, <class 'eventproxy4xi.EventProxy4Xi'>),
            #                     'Iterator': (None,                                      ('send', 'throw', 'close', 'sense', 'reason', 'ace'),          None, <class 'iteratorproxy4xi.IteratorProxy4Xi'>), 
            #          'BoundedSemaphore4Xi': (<function BoundedSemaphore at 0x02837CD8>, ('acquire', 'release', 'sense', 'reason', 'ace'),              None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
            #                     'Array4Xi': (<function Array4Xi at 0x02ECDA50>,         ('__len__', '__getitem__', '__setitem__'),                     None, <class 'arrayproxy4xi.ArrayProxy4Xi'>), 
            #                         'list': (<class 'list'>,                            ('sense', 'reason', 'ace'),                                    None, <class 'listproxy4xi.ListProxy4Xi'>), 
            #                     'Queue4Xi': (<class 'queue.Queue'>,                     None,                                                          None, <function AutoProxy4Xi at 0x02EDF0C0>), 
            #                      'Pool4Xi': (<class 'pool4xi.Pool4Xi'>,                 ('apply', 'apply_async', 'close', 'imap', 'imap_unordered', 'join', 'map', 'map_async', 'terminate', 'sense', 'reason', 'ace'), {'apply_async': 'AsyncResult', 'imap_unordered': 'Iterator', 'imap': 'Iterator', 'map_async': 'AsyncResult'}, <class 'poolproxy4xi.PoolProxy4Xi'>), 
            #                      'Lock4Xi': (<built-in function allocate_lock>,         ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
            #                 'Semaphore4Xi': (<function Semaphore at 0x028379C0>,        ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
            #                     'RLock4Xi': (<function RLock at 0x028376F0>,            ('acquire', 'release', 'sense', 'reason', 'ace'), None, <class 'acquirerproxy4xi.AcquirerProxy4Xi'>), 
            #                         'dict': (<class 'dict'>,                            ('__contains__', '__delitem__', '__getitem__', '__len__', '__setitem__', 'clear', 'copy', 'get', 'has_key', 'items', 'keys', 'pop', 'popitem', 'setdefault', 'update', 'values', 'sense', 'reason', 'ace'), None, <class 'dictproxy4xi.DictProxy4Xi'>),
            #             'JoinableQueue4Xi': (<class 'queue.Queue'>,                     None, None, <function AutoProxy4Xi at 0x02EDF0C0>), 
            #                     'Value4Xi': (<class 'value4xi.Value4Xi'>,               ('get', 'set', 'sense', 'reason', 'ace'), None, <class 'valueproxy4xi.ValueProxy4Xi'>), 
            #                 'Namespace4Xi': (<class 'namespace4xi.Namespace4Xi'>,       ('__getattribute__', '__setattr__', '__delattr__', 'sense', 'reason', 'ace'), None, <class 'namespaceproxy4xi.NamespaceProxy4Xi'>)},
            # 'afterfork2xi-of-SyncManager4Xi': <after_fork4xi.AfterFork4Xi object at 0x02FED2F0>}
    
            
        # -------------------------------------------------------------------------------------    
        # (Step 5/5)
        # -------------------------------------------------------------------------------------
                            
        message2print = "{(Step 5/5) returning" + "; manager2xi-returning-by-Manager4Xi: " + str(manager2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        #<syncmanager4xi.SyncManager4Xi object at 0x033DB9F0>
            
        return manager2xi              
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History of manager4xi.py                             
# ------------------------------------------------------------------------------------------------- 

#<record4xi record = "
# test_proxy_mp_xi4.txt
# sense-proxy-mp-test4xi.xml
# reason-proxy-mp-test4xi.xml
# ace-proxy-mp-test4xi.xml


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of manager4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



